diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ap-wifi-mac.cc ns-3.46/src/wifi/model/ap-wifi-mac.cc
--- ns-3.45/src/wifi/model/ap-wifi-mac.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ap-wifi-mac.cc	2025-10-01 18:46:32.000000000 -0700
@@ -2148,6 +2148,7 @@
                     MgtEmlOmn frame;
                     pkt->RemoveHeader(frame);
                     ReceiveEmlOmn(frame, hdr->GetAddr2(), linkId);
+                    RespondToEmlOmn(frame, hdr->GetAddr2(), linkId);
                     return;
                 }
                 break;
@@ -2488,7 +2489,7 @@
 }
 
 void
-ApWifiMac::ReceiveEmlOmn(MgtEmlOmn& frame, const Mac48Address& sender, uint8_t linkId)
+ApWifiMac::ReceiveEmlOmn(const MgtEmlOmn& frame, const Mac48Address& sender, uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << frame << sender << linkId);
 
@@ -2512,11 +2513,12 @@
         emlCapabilities->get().emlsrPaddingDelay = frame.m_emlsrParamUpdate->paddingDelay;
         emlCapabilities->get().emlsrTransitionDelay = frame.m_emlsrParamUpdate->transitionDelay;
     }
+}
 
-    auto mldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(sender);
-    NS_ASSERT_MSG(mldAddress, "No MLD address stored for STA " << sender);
-    auto emlsrLinks =
-        frame.m_emlControl.emlsrMode == 1 ? frame.GetLinkBitmap() : std::list<uint8_t>{};
+void
+ApWifiMac::RespondToEmlOmn(MgtEmlOmn frame, const Mac48Address& sender, uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << frame << sender << linkId);
 
     // The AP MLD has to consider the changes carried by the received EML Notification frame
     // as effective at the same time as the non-AP MLD. Therefore, we need to start a time
@@ -2532,65 +2534,13 @@
             auto ackDuration =
                 WifiPhy::CalculateTxDuration(psduMap, txVector, GetLink(linkId).phy->GetPhyBand());
 
-            m_transitionTimeoutEvents[sender] = Simulator::Schedule(
-                ackDuration + ehtConfiguration->m_transitionTimeout,
-                [=, this]() {
-                    for (uint8_t id = 0; id < GetNLinks(); id++)
-                    {
-                        auto linkAddress =
-                            GetWifiRemoteStationManager(id)->GetAffiliatedStaAddress(*mldAddress);
-                        if (!linkAddress)
-                        {
-                            // this link has not been setup by the non-AP MLD
-                            continue;
-                        }
-
-                        if (!emlsrLinks.empty())
-                        {
-                            // the non-AP MLD is enabling EMLSR mode
-                            /**
-                             * After the successful transmission of the EML Operating Mode
-                             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
-                             * the non-AP MLD shall operate in the EMLSR mode and the other non-AP
-                             * STAs operating on the corresponding EMLSR links shall transition to
-                             * active mode after the transition delay indicated in the Transition
-                             * Timeout subfield in the EML Capabilities subfield of the Basic
-                             * Multi-Link element or immediately after receiving an EML Operating
-                             * Mode Notification frame from one of the APs operating on the EMLSR
-                             * links and affiliated with the AP MLD (Sec. 35.3.17 of 802.11be D3.0)
-                             */
-                            auto enabled = std::find(emlsrLinks.cbegin(), emlsrLinks.cend(), id) !=
-                                           emlsrLinks.cend();
-                            if (enabled)
-                            {
-                                StaSwitchingToActiveModeOrDeassociated(*linkAddress, id);
-                            }
-                            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, enabled);
-                        }
-                        else
-                        {
-                            // the non-AP MLD is disabling EMLSR mode
-                            /**
-                             * After the successful transmission of the EML Operating Mode
-                             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
-                             * the non-AP MLD shall disable the EMLSR mode and the other non-AP
-                             * STAs operating on the corresponding EMLSR links shall transition to
-                             * power save mode after the transition delay indicated in the
-                             * Transition Timeout subfield in the EML Capabilities subfield of the
-                             * Basic Multi-Link element or immediately after receiving an EML
-                             * Operating Mode Notification frame from one of the APs operating on
-                             * the EMLSR links and affiliated with the AP MLD. (Sec. 35.3.17 of
-                             * 802.11be D3.0)
-                             */
-                            if (id != linkId &&
-                                GetWifiRemoteStationManager(id)->GetEmlsrEnabled(*linkAddress))
-                            {
-                                StaSwitchingToPsMode(*linkAddress, id);
-                            }
-                            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, false);
-                        }
-                    }
-                });
+            m_transitionTimeoutEvents[sender] =
+                Simulator::Schedule(ackDuration + GetEhtConfiguration()->m_transitionTimeout,
+                                    &ApWifiMac::EmlOmnExchangeCompleted,
+                                    this,
+                                    frame,
+                                    sender,
+                                    linkId);
         });
 
     // connect the callback to the PHY TX begin trace to catch the Ack and disconnect
@@ -2621,6 +2571,73 @@
 }
 
 void
+ApWifiMac::EmlOmnExchangeCompleted(const MgtEmlOmn& frame,
+                                   const Mac48Address& sender,
+                                   uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << frame << sender << linkId);
+
+    auto mldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(sender);
+    NS_ASSERT_MSG(mldAddress, "No MLD address stored for STA " << sender);
+    auto emlsrLinks =
+        frame.m_emlControl.emlsrMode == 1 ? frame.GetLinkBitmap() : std::list<uint8_t>{};
+
+    for (uint8_t id = 0; id < GetNLinks(); id++)
+    {
+        auto linkAddress = GetWifiRemoteStationManager(id)->GetAffiliatedStaAddress(*mldAddress);
+        if (!linkAddress)
+        {
+            // this link has not been setup by the non-AP MLD
+            continue;
+        }
+
+        if (!emlsrLinks.empty())
+        {
+            // the non-AP MLD is enabling EMLSR mode
+            /**
+             * After the successful transmission of the EML Operating Mode
+             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
+             * the non-AP MLD shall operate in the EMLSR mode and the other non-AP
+             * STAs operating on the corresponding EMLSR links shall transition to
+             * active mode after the transition delay indicated in the Transition
+             * Timeout subfield in the EML Capabilities subfield of the Basic
+             * Multi-Link element or immediately after receiving an EML Operating
+             * Mode Notification frame from one of the APs operating on the EMLSR
+             * links and affiliated with the AP MLD (Sec. 35.3.17 of 802.11be D3.0)
+             */
+            auto enabled =
+                std::find(emlsrLinks.cbegin(), emlsrLinks.cend(), id) != emlsrLinks.cend();
+            if (enabled)
+            {
+                StaSwitchingToActiveModeOrDeassociated(*linkAddress, id);
+            }
+            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, enabled);
+        }
+        else
+        {
+            // the non-AP MLD is disabling EMLSR mode
+            /**
+             * After the successful transmission of the EML Operating Mode
+             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
+             * the non-AP MLD shall disable the EMLSR mode and the other non-AP
+             * STAs operating on the corresponding EMLSR links shall transition to
+             * power save mode after the transition delay indicated in the
+             * Transition Timeout subfield in the EML Capabilities subfield of the
+             * Basic Multi-Link element or immediately after receiving an EML
+             * Operating Mode Notification frame from one of the APs operating on
+             * the EMLSR links and affiliated with the AP MLD. (Sec. 35.3.17 of
+             * 802.11be D3.0)
+             */
+            if (id != linkId && GetWifiRemoteStationManager(id)->GetEmlsrEnabled(*linkAddress))
+            {
+                StaSwitchingToPsMode(*linkAddress, id);
+            }
+            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, false);
+        }
+    }
+}
+
+void
 ApWifiMac::DeaggregateAmsduAndForward(Ptr<const WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ap-wifi-mac.h ns-3.46/src/wifi/model/ap-wifi-mac.h
--- ns-3.45/src/wifi/model/ap-wifi-mac.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ap-wifi-mac.h	2025-10-01 18:46:32.000000000 -0700
@@ -59,6 +59,8 @@
 class ApWifiMac : public WifiMac
 {
   public:
+    friend class WifiStaticSetupHelper;
+
     /**
      * @brief Get the type ID.
      * @return the object TypeId
@@ -329,14 +331,36 @@
     void ParseReportedStaInfo(const AssocReqRefVariant& assoc, Mac48Address from, uint8_t linkId);
 
     /**
-     * Take necessary actions upon receiving the given EML Operating Mode Notification frame
-     * from the given station on the given link.
+     * Process the EML Operating Mode Notification frame received from the given station on the
+     * given link.
+     *
+     * @param frame the received EML Operating Mode Notification frame
+     * @param sender the MAC address of the sender of the frame
+     * @param linkId the ID of the link over which the frame was received
+     */
+    void ReceiveEmlOmn(const MgtEmlOmn& frame, const Mac48Address& sender, uint8_t linkId);
+
+    /**
+     * Respond to the EML Operating Mode Notification frame received from the given station on the
+     * given link.
+     *
+     * @param frame the received EML Operating Mode Notification frame
+     * @param sender the MAC address of the sender of the frame
+     * @param linkId the ID of the link over which the frame was received
+     */
+    void RespondToEmlOmn(MgtEmlOmn frame, const Mac48Address& sender, uint8_t linkId);
+
+    /**
+     * Take necessary actions upon completion of an exchange of EML Operating Mode Notification
+     * frames.
      *
      * @param frame the received EML Operating Mode Notification frame
      * @param sender the MAC address of the sender of the frame
      * @param linkId the ID of the link over which the frame was received
      */
-    void ReceiveEmlOmn(MgtEmlOmn& frame, const Mac48Address& sender, uint8_t linkId);
+    void EmlOmnExchangeCompleted(const MgtEmlOmn& frame,
+                                 const Mac48Address& sender,
+                                 uint8_t linkId);
 
     /**
      * The packet we sent was successfully received by the receiver
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/block-ack-manager.cc ns-3.46/src/wifi/model/block-ack-manager.cc
--- ns-3.45/src/wifi/model/block-ack-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/block-ack-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1000,7 +1000,10 @@
 
     uint8_t tid = reqHdr.GetTidInfo();
 
-    WifiContainerQueueId queueId(WIFI_CTL_QUEUE, WIFI_UNICAST, hdr.GetAddr1(), std::nullopt);
+    WifiContainerQueueId queueId(WIFI_CTL_QUEUE,
+                                 WifiRcvAddr::UNICAST,
+                                 hdr.GetAddr1(),
+                                 std::nullopt);
     auto pkt = Create<Packet>();
     pkt->AddHeader(reqHdr);
     Ptr<WifiMpdu> item = nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/block-ack-manager.h ns-3.46/src/wifi/model/block-ack-manager.h
--- ns-3.45/src/wifi/model/block-ack-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/block-ack-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -414,7 +414,7 @@
     void SetTxOkCallback(TxOk callback);
     /**
      * @param callback the callback to invoke when a
-     * packet transmission was completed unsuccessfuly.
+     * packet transmission was completed unsuccessfully.
      */
     void SetTxFailedCallback(TxFailed callback);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/channel-access-manager.cc ns-3.46/src/wifi/model/channel-access-manager.cc
--- ns-3.45/src/wifi/model/channel-access-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/channel-access-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -17,6 +17,7 @@
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 
+#include <cmath>
 #include <sstream>
 
 #undef NS_LOG_APPEND_CONTEXT
@@ -189,7 +190,8 @@
                           MakeBooleanAccessor(&ChannelAccessManager::m_proactiveBackoff),
                           MakeBooleanChecker())
             .AddAttribute("ResetBackoffThreshold",
-                          "If no PHY operates on this link for a period greater than this "
+                          "If no PHY operates on this link, or the PHY operating on this link "
+                          "stays in sleep mode or off mode, for a period greater than this "
                           "threshold, all the backoffs are reset.",
                           TimeValue(Time{0}),
                           MakeTimeAccessor(&ChannelAccessManager::m_resetBackoffThreshold),
@@ -225,8 +227,6 @@
       m_lastRxReceivedOk(true),
       m_lastTxEnd(0),
       m_lastSwitchingEnd(0),
-      m_lastSleepEnd(0),
-      m_lastOffEnd(0),
       m_linkId(0)
 {
     NS_LOG_FUNCTION(this);
@@ -249,11 +249,7 @@
 ChannelAccessManager::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (Ptr<Txop> i : m_txops)
-    {
-        i->Dispose();
-        i = nullptr;
-    }
+    m_txops.clear();
     m_phy = nullptr;
     m_feManager = nullptr;
     m_phyListeners.clear();
@@ -591,13 +587,13 @@
      */
     Time accessGrantStart = GetAccessGrantStart() + (txop->GetAifsn(m_linkId) * GetSlot());
 
-    if (txop->IsQosTxop() && txop->GetBackoffStart(m_linkId) > accessGrantStart)
+    if (const auto diff = txop->GetBackoffStart(m_linkId) - accessGrantStart;
+        txop->IsQosTxop() && diff.IsStrictlyPositive())
     {
-        // The backoff start time reported by the EDCAF is more recent than the last
-        // time the medium was busy plus an AIFS, hence we need to align it to the
-        // next slot boundary.
-        Time diff = txop->GetBackoffStart(m_linkId) - accessGrantStart;
-        uint32_t nIntSlots = (diff / GetSlot()).GetHigh() + 1;
+        // The backoff start time reported by the EDCAF is more recent than the last time the medium
+        // was busy plus an AIFS, hence we need to align it to the next slot boundary.
+        const auto div = diff / GetSlot();
+        const uint32_t nIntSlots = div.GetHigh() + (div.GetLow() > 0 ? 1 : 0);
         txop->UpdateBackoffSlotsNow(0, accessGrantStart + (nIntSlots * GetSlot()), m_linkId);
     }
 
@@ -615,6 +611,12 @@
     uint32_t k = 0;
     const auto now = Simulator::Now();
     const auto accessGrantStart = GetAccessGrantStart();
+    if (accessGrantStart > now)
+    {
+        NS_LOG_DEBUG("access cannot be granted yet");
+        return;
+    }
+
     for (auto i = m_txops.begin(); i != m_txops.end(); k++)
     {
         Ptr<Txop> txop = *i;
@@ -697,7 +699,14 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (!m_phy && Simulator::Now() - m_lastNoPhy.start > m_resetBackoffThreshold)
+    const auto now = Simulator::Now();
+    const auto noPhyForTooLong = (!m_phy && now - m_lastNoPhy.start > m_resetBackoffThreshold);
+    const auto sleepForTooLong =
+        (m_phy && m_phy->IsStateSleep() && now - m_lastSleep.start > m_resetBackoffThreshold);
+    const auto offForTooLong =
+        (m_phy && m_phy->IsStateOff() && now - m_lastOff.start > m_resetBackoffThreshold);
+
+    if (noPhyForTooLong || sleepForTooLong || offForTooLong)
     {
         ResetAllBackoffs();
         return;
@@ -740,8 +749,11 @@
     const auto noPhyStart = m_phy ? m_lastNoPhy.end : now;
     ret.emplace(noPhyStart, WifiExpectedAccessReason::NO_PHY_END);
 
-    ret.emplace(m_lastSleepEnd, WifiExpectedAccessReason::SLEEP_END);
-    ret.emplace(m_lastOffEnd, WifiExpectedAccessReason::OFF_END);
+    const auto lastSleepEnd = (m_lastSleep.start > m_lastSleep.end ? now : m_lastSleep.end);
+    ret.emplace(lastSleepEnd, WifiExpectedAccessReason::SLEEP_END);
+
+    const auto lastOffEnd = (m_lastOff.start > m_lastOff.end ? now : m_lastOff.end);
+    ret.emplace(lastOffEnd, WifiExpectedAccessReason::OFF_END);
 
     NS_LOG_INFO("rx access start=" << rxAccessStart.As(Time::US)
                                    << ", busy access start=" << busyAccessStart.As(Time::US)
@@ -749,8 +761,8 @@
                                    << ", nav access start=" << navAccessStart.As(Time::US)
                                    << ", switching access start=" << m_lastSwitchingEnd.As(Time::US)
                                    << ", no PHY start=" << noPhyStart.As(Time::US)
-                                   << ", sleep access start=" << m_lastSleepEnd.As(Time::US)
-                                   << ", off access start=" << m_lastOffEnd.As(Time::US));
+                                   << ", sleep access start=" << lastSleepEnd.As(Time::US)
+                                   << ", off access start=" << lastOffEnd.As(Time::US));
     return ret;
 }
 
@@ -1220,6 +1232,8 @@
     m_lastAckTimeoutEnd = std::min(m_lastAckTimeoutEnd, now);
     m_lastCtsTimeoutEnd = std::min(m_lastCtsTimeoutEnd, now);
     m_lastNoPhy.end = std::min(m_lastNoPhy.end, now);
+    m_lastSleep.end = std::min(m_lastSleep.end, now);
+    m_lastOff.end = std::min(m_lastOff.end, now);
 
     InitLastBusyStructs();
 }
@@ -1255,8 +1269,9 @@
 ChannelAccessManager::NotifySleepNow()
 {
     NS_LOG_FUNCTION(this);
-    // Reset backoffs
-    ResetAllBackoffs();
+    UpdateBackoff();
+    UpdateLastIdlePeriod();
+    m_lastSleep.start = Simulator::Now();
     m_feManager->NotifySleepNow();
     for (auto txop : m_txops)
     {
@@ -1268,16 +1283,13 @@
 ChannelAccessManager::NotifyOffNow()
 {
     NS_LOG_FUNCTION(this);
-    // Cancel timeout
-    if (m_accessTimeout.IsPending())
-    {
-        m_accessTimeout.Cancel();
-    }
-
-    // Reset backoffs
+    UpdateBackoff();
+    UpdateLastIdlePeriod();
+    m_lastOff.start = Simulator::Now();
+    m_feManager->NotifyOffNow();
     for (auto txop : m_txops)
     {
-        txop->NotifyOff();
+        txop->NotifyOff(m_linkId);
     }
 }
 
@@ -1285,10 +1297,14 @@
 ChannelAccessManager::NotifyWakeupNow()
 {
     NS_LOG_FUNCTION(this);
-    m_lastSleepEnd = Simulator::Now();
+    const auto now = Simulator::Now();
+    m_lastSleep.end = now;
+    if (now - m_lastSleep.start > m_resetBackoffThreshold)
+    {
+        ResetAllBackoffs();
+    }
     for (auto txop : m_txops)
     {
-        ResetBackoff(txop);
         txop->NotifyWakeUp(m_linkId);
     }
 }
@@ -1297,10 +1313,14 @@
 ChannelAccessManager::NotifyOnNow()
 {
     NS_LOG_FUNCTION(this);
-    m_lastOffEnd = Simulator::Now();
+    const auto now = Simulator::Now();
+    m_lastOff.end = now;
+    if (now - m_lastOff.start > m_resetBackoffThreshold)
+    {
+        ResetAllBackoffs();
+    }
     for (auto txop : m_txops)
     {
-        ResetBackoff(txop);
         txop->NotifyOn();
     }
 }
@@ -1377,8 +1397,8 @@
                                m_lastRx.end,
                                m_lastSwitchingEnd,
                                m_lastNoPhy.end,
-                               m_lastSleepEnd,
-                               m_lastOffEnd});
+                               m_lastSleep.end,
+                               m_lastOff.end});
     Time now = Simulator::Now();
 
     if (idleStart >= now)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/channel-access-manager.h ns-3.46/src/wifi/model/channel-access-manager.h
--- ns-3.45/src/wifi/model/channel-access-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/channel-access-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -275,7 +275,7 @@
     void NotifyRxEndOkNow();
     /**
      * Notify the Txop that a packet reception was just
-     * completed unsuccessfuly.
+     * completed unsuccessfully.
      *
      * @param txVector the TXVECTOR used for transmission
      */
@@ -536,8 +536,8 @@
     std::map<WifiChannelListType, Timespan>
         m_lastIdle;               //!< the last idle start and end time for each channel type
     Time m_lastSwitchingEnd;      //!< the last switching end time
-    Time m_lastSleepEnd;          //!< the last sleep end time
-    Time m_lastOffEnd;            //!< the last off end time
+    Timespan m_lastSleep;         //!< the last sleep start and end time
+    Timespan m_lastOff;           //!< the last off start and end time
     Time m_eifsNoDifs;            //!< EIFS no DIFS time
     Timespan m_lastNoPhy;         //!< the last start and end time no PHY was operating on the link
     mutable Time m_cachedSifs;    //!< cached value for SIFS, to be only used without a PHY
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ctrl-headers.cc ns-3.46/src/wifi/model/ctrl-headers.cc
--- ns-3.45/src/wifi/model/ctrl-headers.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ctrl-headers.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1188,7 +1188,7 @@
       m_ulMcs(0),
       m_ulDcm(false),
       m_ps160(false),
-      m_ulTargetRssi(0),
+      m_ulTargetRxPower(0),
       m_triggerType(triggerType),
       m_basicTriggerDependentUserInfo(0)
 {
@@ -1218,7 +1218,7 @@
     m_ulDcm = userInfo.m_ulDcm;
     m_ps160 = userInfo.m_ps160;
     m_bits26To31 = userInfo.m_bits26To31;
-    m_ulTargetRssi = userInfo.m_ulTargetRssi;
+    m_ulTargetRxPower = userInfo.m_ulTargetRxPower;
     m_basicTriggerDependentUserInfo = userInfo.m_basicTriggerDependentUserInfo;
     m_muBarTriggerDependentUserInfo = userInfo.m_muBarTriggerDependentUserInfo;
     return *this;
@@ -1291,7 +1291,7 @@
     i.WriteHtolsbU32(userInfo);
     // Here we need to write 8 bits covering the UL Target RSSI (7 bits) and B39, which is
     // reserved in the HE variant and the PS160 subfield in the EHT variant.
-    uint8_t bit32To39 = m_ulTargetRssi;
+    uint8_t bit32To39 = m_ulTargetRxPower;
     if (m_variant == TriggerFrameVariant::EHT)
     {
         bit32To39 |= (m_ps160 ? 1 << 7 : 0);
@@ -1348,7 +1348,7 @@
     }
 
     uint8_t bit32To39 = i.ReadU8();
-    m_ulTargetRssi = bit32To39 & 0x7f; // B39 is reserved in HE variant
+    m_ulTargetRxPower = bit32To39 & 0x7f; // B39 is reserved in HE variant
     if (m_variant == TriggerFrameVariant::EHT)
     {
         m_ps160 = (bit32To39 >> 7) == 1;
@@ -1677,31 +1677,31 @@
 }
 
 void
-CtrlTriggerUserInfoField::SetUlTargetRssiMaxTxPower()
+CtrlTriggerUserInfoField::SetUlTargetRxPowerMaxTxPower()
 {
-    m_ulTargetRssi = 127; // see Table 9-25i of 802.11ax amendment D3.0
+    m_ulTargetRxPower = 127; // see Table 9-54 of 802.11-2024
 }
 
 void
-CtrlTriggerUserInfoField::SetUlTargetRssi(int8_t dBm)
+CtrlTriggerUserInfoField::SetUlTargetRxPower(int8_t dBm)
 {
     NS_ABORT_MSG_IF(dBm < -110 || dBm > -20, "Invalid values for signal power");
 
-    m_ulTargetRssi = static_cast<uint8_t>(110 + dBm);
+    m_ulTargetRxPower = static_cast<uint8_t>(110 + dBm);
 }
 
 bool
-CtrlTriggerUserInfoField::IsUlTargetRssiMaxTxPower() const
+CtrlTriggerUserInfoField::IsUlTargetRxPowerMaxTxPower() const
 {
-    return (m_ulTargetRssi == 127);
+    return (m_ulTargetRxPower == 127);
 }
 
 int8_t
-CtrlTriggerUserInfoField::GetUlTargetRssi() const
+CtrlTriggerUserInfoField::GetUlTargetRxPower() const
 {
-    NS_ABORT_MSG_IF(m_ulTargetRssi == 127, "STA must use its max TX power");
+    NS_ABORT_MSG_IF(m_ulTargetRxPower == 127, "STA must use its max TX power");
 
-    return static_cast<int8_t>(m_ulTargetRssi) - 110;
+    return static_cast<int8_t>(m_ulTargetRxPower) - 110;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ctrl-headers.h ns-3.46/src/wifi/model/ctrl-headers.h
--- ns-3.45/src/wifi/model/ctrl-headers.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ctrl-headers.h	2025-10-01 18:46:32.000000000 -0700
@@ -803,32 +803,32 @@
      */
     bool GetMoreRaRu() const;
     /**
-     * Set the UL Target RSSI subfield to indicate to the station to transmit an
+     * Set the UL Target Receive Power subfield to indicate to the station to transmit an
      * HE TB PPDU response at its maximum transmit power for the assigned MCS
      */
-    void SetUlTargetRssiMaxTxPower();
+    void SetUlTargetRxPowerMaxTxPower();
     /**
-     * Set the UL Target RSSI subfield to indicate the expected receive signal
+     * Set the UL Target Receive Power subfield to indicate the expected receive signal
      * power in dBm
      *
      * @param dBm the expected receive signal power (a value between -110 and -20)
      */
-    void SetUlTargetRssi(int8_t dBm);
+    void SetUlTargetRxPower(int8_t dBm);
     /**
-     * Return true if the UL Target RSSI subfield indicates to the station to transmit
+     * Return true if the UL Target Receive Power subfield indicates to the station to transmit
      * an HE TB PPDU response at its maximum transmit power for the assigned MCS
      *
-     * @return true if the UL Target RSSI subfield indicates to the station to transmit
+     * @return true if the UL Target Receive Power subfield indicates to the station to transmit
      * an HE TB PPDU response at its maximum transmit power for the assigned MCS
      */
-    bool IsUlTargetRssiMaxTxPower() const;
+    bool IsUlTargetRxPowerMaxTxPower() const;
     /**
      * Get the expected receive signal power for the solicited HE TB PPDU. This
-     * method can only be called if IsUlTargetRssiMaxTxPower returns false.
+     * method can only be called if IsUlTargetRxPowerMaxTxPower returns false.
      *
      * @return the expected receive signal power in dBm
      */
-    int8_t GetUlTargetRssi() const;
+    int8_t GetUlTargetRxPower() const;
     /**
      * Set the Trigger Dependent User Info subfield for Basic Trigger frames.
      *
@@ -903,7 +903,7 @@
         } raRuInformation; //!< Used when AID12 is 0 or 2045
     } m_bits26To31;        //!< Fields occupying bits 26-31 in the User Info field
 
-    uint8_t m_ulTargetRssi;                  //!< Expected receive signal power
+    uint8_t m_ulTargetRxPower;               //!< Expected receive signal power
     TriggerFrameType m_triggerType;          //!< Trigger frame type
     uint8_t m_basicTriggerDependentUserInfo; //!< Basic Trigger variant of Trigger Dependent User
                                              //!< Info subfield
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.cc ns-3.46/src/wifi/model/eht/advanced-emlsr-manager.cc
--- ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/advanced-emlsr-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -329,9 +329,10 @@
     NS_LOG_FUNCTION(this << *linkId << macHdr << txVector << psduDuration.As(Time::MS));
 
     auto& ongoingTxopEnd = GetEhtFem(*linkId)->GetOngoingTxopEndEvent();
+    const auto isMainPhy = (phy->GetPhyId() == GetMainPhyId());
 
     if (ongoingTxopEnd.IsPending() && macHdr.GetAddr1() != GetEhtFem(*linkId)->GetAddress() &&
-        !macHdr.GetAddr1().IsBroadcast() &&
+        !macHdr.IsTrigger() && !macHdr.IsBlockAck() &&
         !(macHdr.IsCts() && macHdr.GetAddr1() == GetEhtFem(*linkId)->GetBssid() /* CTS-to-self */))
     {
         // the EMLSR client is no longer involved in the TXOP and switching to listening mode
@@ -346,13 +347,30 @@
         Simulator::ScheduleNow(&AdvancedEmlsrManager::NotifyTxopEnd, this, *linkId, nullptr);
     }
 
+    if (!ongoingTxopEnd.IsPending() && GetStaMac()->IsEmlsrLink(*linkId) && isMainPhy &&
+        !GetEhtFem(*linkId)->UsingOtherEmlsrLink() &&
+        (macHdr.IsRts() || macHdr.IsBlockAckReq() || macHdr.IsData()) &&
+        (macHdr.GetAddr1() == GetEhtFem(*linkId)->GetAddress()))
+    {
+        // a frame that is starting a DL TXOP is being received by the main PHY; start blocking
+        // transmission on other links (which is normally done later on by PostProcessFrame()) to
+        // avoid starting an UL TXOP before the end of the MPDU
+        for (auto id : GetStaMac()->GetLinkIds())
+        {
+            if (id != *linkId && GetStaMac()->IsEmlsrLink(id))
+            {
+                GetStaMac()->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
+            }
+        }
+        return;
+    }
+
     // if the MAC header has been received on the link on which the main PHY is operating (or on
     // the link the main PHY is switching to), the switch main PHY back timer is running and channel
     // access is not expected to be gained by the main PHY before the switch main PHY back timer
     // expires (plus a channel switch delay), try to switch the main PHY back to the preferred link
     const auto mainPhyInvolved =
-        (phy->GetPhyId() == GetMainPhyId()) ||
-        (m_mainPhySwitchInfo.disconnected && m_mainPhySwitchInfo.to == *linkId);
+        isMainPhy || (m_mainPhySwitchInfo.disconnected && m_mainPhySwitchInfo.to == *linkId);
     const auto delay =
         Simulator::GetDelayLeft(m_switchMainPhyBackEvent) + phy->GetChannelSwitchDelay();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/eht-configuration.h ns-3.46/src/wifi/model/eht/eht-configuration.h
--- ns-3.45/src/wifi/model/eht/eht-configuration.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/eht-configuration.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,7 +10,6 @@
 #ifndef EHT_CONFIGURATION_H
 #define EHT_CONFIGURATION_H
 
-#include "ns3/deprecated.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/wifi-utils.h"
@@ -41,23 +40,6 @@
 };
 
 /**
- * Deprecated link mapping support enums.
- *
- * Use `WifiTidToLinkMappingNegSupport` class enum values instead.
- * @{
- */
-NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::NOT_SUPPORTED instead")
-static constexpr auto WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED =
-    WifiTidToLinkMappingNegSupport::NOT_SUPPORTED;
-NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::SAME_LINK_SET instead")
-static constexpr auto WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET =
-    WifiTidToLinkMappingNegSupport::SAME_LINK_SET;
-NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::ANY_LINK_SET instead")
-static constexpr auto WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET =
-    WifiTidToLinkMappingNegSupport::ANY_LINK_SET;
-/**@}*/
-
-/**
  * @brief Stream insertion operator.
  * @param [in] os The reference to the output stream.
  * @param [in] negsupport The WifiTidToLinkMappingNegSupport.
